//Downloaded from
//Visual C# Kicks - http://vckicks.110mb.com/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ScreenLock
{
    public partial class AdvanceLock : Form
    {
        public AdvanceLock()
        {
            //This form works the same as SimpleLock except that it also writes itself to the Registry
            //That way even if the computer is restarted, the program will run as soon as windows 
            //starts up again

            InitializeComponent();

            //Get a bare, black form to cover the entire screen
            this.BackColor = Color.Black;
            this.CausesValidation = false;
            this.StartPosition = FormStartPosition.Manual;
            this.WindowState = FormWindowState.Maximized;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.ShowInTaskbar = false;
            this.TopMost = true;

            //Set the password textbox
            txtPassword.PasswordChar = '*';
            txtPassword.TextAlign = HorizontalAlignment.Center;
            txtPassword.BackColor = Color.DarkGray;
            txtPassword.ForeColor = Color.Yellow;
            txtPassword.BorderStyle = BorderStyle.None;

            //Timers
            layerTimer.Interval = 1;
            layerTimer.Enabled = true;

            registryTimer.Interval = 5000;
            registryTimer.Enabled = true;
        }

        int tries;
        bool approveClose;
        bool safeUnregister;

        private void Form1_Load(object sender, EventArgs e)
        {
            //Place the password textbox in the middle
            txtPassword.Left = (this.Width / 2) - (txtPassword.Width / 2);
            txtPassword.Top = (this.Height / 2) - (txtPassword.Height / 2);
        }

        private void txtPassword_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == Convert.ToChar(Keys.Enter))
            {
                //Check the password
                //Can use fancy algorithm or simple check
                //depends on the purpose, for here we'll just check
                //that the string matches the password
                if (txtPassword.Text == "password")
                {
                    approveClose = true;
                    this.Close();
                }
                else
                {
                    tries++;
                    txtPassword.Text = string.Empty;

                    if (tries >= 3) //too many tries, disable
                    {
                        txtPassword.Enabled = false;
                        txtPassword.Visible = false;
                    }
                }
            }
        }

        private void layerTimer_Tick(object sender, EventArgs e)
        {
            //this is a brute force way of doing things, but by constantly
            //bringing our top-most form to the front, we can prevent
            //anything else from showing up on top (like TaskManager for example)
            this.BringToFront();
            if (!txtPassword.Focused) txtPassword.Focus();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            //If the form wasn't closed by entering the proper password (like Alt F40
            //run the program again
            if (!approveClose)
                System.Diagnostics.Process.Start(Application.ExecutablePath);
        }

        private void register()
        {
            Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.LocalMachine;
            //if you prefer the screen lock to run for only the current user, use
            //Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.CurrentUser;
            try
            {
                key.CreateSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Run").SetValue("~", Application.ExecutablePath);
                key.Close();
            }
            catch (Exception)
            {
            }            
        }

        private Boolean isRegistered()
        {
            try
            {
                Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.LocalMachine;
                //if you prefer the screen lock to run for only the current user, use
                //Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.CurrentUser;

                bool keyOpen = key.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Run").GetValue("~").ToString() != "";
                return keyOpen;
            }
            catch (Exception)
            {
                return false; //key didn't exist                
            }
        }

        private void unregister()
        {
            if (isRegistered())
            {
                safeUnregister = true;

                Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.LocalMachine;
                //if you prefer the screen lock to run for only the current user, use
                //Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.CurrentUser;

                key.OpenSubKey(@"SOFTWARE\Microsoft\Windows\CurrentVersion\Run", true).DeleteValue("~");
            }
            else
                safeUnregister = false;
        }

        private void registryTimer_Tick(object sender, EventArgs e)
        {
            if (safeUnregister == false && !isRegistered()) register();
        }
    }
}